---
title: OVR_multiview2
slug: Web/API/OVR_multiview2
tags:
  - API
  - WebGL
  - WebGL extensions
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code>OVR_multiview2</code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and adds support for rendering into multiple views simultaneously. This especially useful for virtual reality (VR) and WebXR.</p>

<p>For more information, see also:</p>

<ul>
	<li><a href="https://blog.mozvr.com/multiview-on-webxr/">Multiview on WebXR</a></li>
	<li><a href="https://threejs.org/examples/webxr_vr_multiview">three.js multiview demo</a></li>
	<li><a href="https://doc.babylonjs.com/how_to/multiview">Multiview in babylon.js</a></li>
	<li><a href="https://community.arm.com/developer/tools-software/graphics/b/blog/posts/optimizing-virtual-reality-understanding-multiview">Optimizing Virtual Reality: Understanding Multiview</a></li>
	<li><a href="https://developer.oculus.com/documentation/oculus-browser/latest/concepts/browser-multiview/">Multiview WebGL Rendering for Oculus Browser 6.0+</a></li>
</ul>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability: </strong>Support depends on the system's graphics driver (Windows+ANGLE and Android are supported; Windows+GL, Mac, Linux are not supported).</p>

<p>This extension is only available to {{domxref("WebGL2RenderingContext", "WebGL 2", "", 1)}} contexts as it needs GLSL 3.00 and texture arrays.<br>
<br>
Currently, there is no way to use multiview to render to a multisampled backbuffer, so you should create contexts with <code>antialias: false</code>. However, the Oculus browser (6+) also supports multisampling using the <code><a href="https://developer.oculus.com/documentation/oculus-browser/latest/concepts/browser-multiview/#using-multiview-in-webgl-20">OCULUS_multiview</a></code> extension. See also <a href="https://github.com/KhronosGroup/WebGL/issues/2912">this WebGL issue</a>.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>This extension exposes 4 constants that can be used in <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/getParameter">getParameter()</a></code> or <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/getFramebufferAttachmentParameter">getFramebufferAttachmentParameter()</a></code>.</p>

<dl>
	<dt><code>FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR</code></dt>
	<dd>Number of views of the framebuffer object attachment.</dd>
	<dt><code>FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR</code></dt>
	<dd>Base view index of the framebuffer object attachment.</dd>
	<dt><code>MAX_VIEWS_OVR</code></dt>
	<dd>The maximum number of views. Most VR headsets have two views, but there are prototypes of headset with ultra-wide FOV using 4 views which is currently the maximum number of views supported by multiview.</dd>
	<dt><code>FRAMEBUFFER_INCOMPLETE_VIEW_TARGETS_OVR</code></dt>
	<dd>If baseViewIndex is not the same for all framebuffer attachment points where the value of <code>FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE</code> is not <code>NONE</code>, the framebuffer is considered incomplete. Calling <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/checkFramebufferStatus">checkFramebufferStatus</a></code> for a framebuffer in this state returns <code>FRAMEBUFFER_INCOMPLETE_VIEW_TARGETS_OVR</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt><code><a href="/en-US/docs/Web/API/OVR_multiview2/framebufferTextureMultiviewOVR">framebufferTextureMultiviewOVR()</a></code></dt>
	<dd>Simultaneously renders to multiple elements of a 2D texture array.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example is taken from the <a href="https://www.khronos.org/registry/webgl/extensions/OVR_multiview2/">specification</a>. See also this <a href="https://threejs.org/examples/webvr_multiview.html">three.js</a> demo for a live multiview example.</p>

<pre class="brush: js">const gl = document.createElement('canvas').getContext( 'webgl2', { antialias: false } );
const ext = gl.getExtension('OVR_multiview2');
const fb = gl.createFramebuffer();
gl.bindFramebuffer(gl.DRAW_FRAMEBUFFER, fb);

const colorTex = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D_ARRAY, colorTex);
gl.texStorage3D(gl.TEXTURE_2D_ARRAY, 1, gl.RGBA8, 512, 512, 2);
ext.framebufferTextureMultiviewOVR(gl.DRAW_FRAMEBUFFER, gl.COLOR_ATTACHMENT0, colorTex, 0, 0, 2);

const depthStencilTex = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D_ARRAY, depthStencilTex);
gl.texStorage3D(gl.TEXTURE_2D_ARRAY, 1, gl.DEPTH32F_STENCIL8, 512, 512, 2);

ext.framebufferTextureMultiviewOVR(gl.DRAW_FRAMEBUFFER, gl.DEPTH_STENCIL_ATTACHMENT, depthStencilTex, 0, 0, 2);
gl.drawElements(...);  // draw will be broadcasted to the layers of colorTex and depthStencilTex.    </pre>

<p>Shader code</p>

<pre class="brush: cpp">#version 300 es
#extension GL_OVR_multiview2 : require
precision mediump float;
layout (num_views = 2) in;
in vec4 inPos;
uniform mat4 u_viewMatrices[2];
void main() {
  gl_Position = u_viewMatrices[gl_ViewID_OVR] * inPos;
}    </pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
		</tr>
		<tr>
			<td><a href="https://www.khronos.org/registry/webgl/extensions/OVR_multiview2/">OVR_multiview2</a></td>
			<td>Community Approved</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.OVR_multiview2")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
	<li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a></li>
	<li><a href="https://threejs.org/examples/webxr_vr_multiview">three.js multiview demo</a></li>
</ul>
